Index: branches/OKB (trunk integration)/HeuristicLab.OKB.sln
===================================================================
--- branches/OKB (trunk integration)/HeuristicLab.OKB.sln	(revision 5482)
+++ branches/OKB (trunk integration)/HeuristicLab.OKB.sln	(revision 5502)
@@ -3,6 +3,4 @@
 # Visual Studio 2010
 Project("{2150E333-8FDC-42A3-9474-1A3956D46DE8}") = "Solution Items", "Solution Items", "{9E843318-7235-4B2B-81A7-160FDDADD9E1}"
-EndProject
-Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Services.OKB.DataTransfer-3.3", "HeuristicLab.Services.OKB.DataTransfer\3.3\HeuristicLab.Services.OKB.DataTransfer-3.3.csproj", "{209FD7A1-DFB2-4B9F-9268-B95E886B2F7A}"
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Services.OKB.DataAccess-3.3", "HeuristicLab.Services.OKB.DataAccess\3.3\HeuristicLab.Services.OKB.DataAccess-3.3.csproj", "{E36BE58F-F3CE-40BB-9AB3-9F9E30AD5CCF}"
@@ -24,12 +22,4 @@
 	EndGlobalSection
 	GlobalSection(ProjectConfigurationPlatforms) = postSolution
-		{209FD7A1-DFB2-4B9F-9268-B95E886B2F7A}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{209FD7A1-DFB2-4B9F-9268-B95E886B2F7A}.Debug|Any CPU.Build.0 = Debug|Any CPU
-		{209FD7A1-DFB2-4B9F-9268-B95E886B2F7A}.Debug|x64.ActiveCfg = Debug|Any CPU
-		{209FD7A1-DFB2-4B9F-9268-B95E886B2F7A}.Debug|x86.ActiveCfg = Debug|Any CPU
-		{209FD7A1-DFB2-4B9F-9268-B95E886B2F7A}.Release|Any CPU.ActiveCfg = Release|Any CPU
-		{209FD7A1-DFB2-4B9F-9268-B95E886B2F7A}.Release|Any CPU.Build.0 = Release|Any CPU
-		{209FD7A1-DFB2-4B9F-9268-B95E886B2F7A}.Release|x64.ActiveCfg = Release|Any CPU
-		{209FD7A1-DFB2-4B9F-9268-B95E886B2F7A}.Release|x86.ActiveCfg = Release|Any CPU
 		{E36BE58F-F3CE-40BB-9AB3-9F9E30AD5CCF}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{E36BE58F-F3CE-40BB-9AB3-9F9E30AD5CCF}.Debug|Any CPU.Build.0 = Debug|Any CPU
Index: branches/OKB (trunk integration)/HeuristicLab.Services.OKB.DataAccess/3.3/HeuristicLab.Services.OKB.DataAccess-3.3.csproj
===================================================================
--- branches/OKB (trunk integration)/HeuristicLab.Services.OKB.DataAccess/3.3/HeuristicLab.Services.OKB.DataAccess-3.3.csproj	(revision 5482)
+++ branches/OKB (trunk integration)/HeuristicLab.Services.OKB.DataAccess/3.3/HeuristicLab.Services.OKB.DataAccess-3.3.csproj	(revision 5502)
@@ -184,10 +184,4 @@
     <None Include="SQL Scripts\Create OKB.sql" />
   </ItemGroup>
-  <ItemGroup>
-    <ProjectReference Include="..\..\HeuristicLab.Services.OKB.DataTransfer\3.3\HeuristicLab.Services.OKB.DataTransfer-3.3.csproj">
-      <Project>{209FD7A1-DFB2-4B9F-9268-B95E886B2F7A}</Project>
-      <Name>HeuristicLab.Services.OKB.DataTransfer-3.3</Name>
-    </ProjectReference>
-  </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
   <PropertyGroup>
Index: branches/OKB (trunk integration)/HeuristicLab.Services.OKB.DataAccess/3.3/Tests/HeuristicLab.Services.OKB.DataAccess-3.3.Tests.csproj
===================================================================
--- branches/OKB (trunk integration)/HeuristicLab.Services.OKB.DataAccess/3.3/Tests/HeuristicLab.Services.OKB.DataAccess-3.3.Tests.csproj	(revision 5482)
+++ branches/OKB (trunk integration)/HeuristicLab.Services.OKB.DataAccess/3.3/Tests/HeuristicLab.Services.OKB.DataAccess-3.3.Tests.csproj	(revision 5502)
@@ -55,8 +55,4 @@
       <Name>HeuristicLab.Clients.OKB-3.3</Name>
     </ProjectReference>
-    <ProjectReference Include="..\..\..\HeuristicLab.Services.OKB.DataTransfer\3.3\HeuristicLab.Services.OKB.DataTransfer-3.3.csproj">
-      <Project>{209FD7A1-DFB2-4B9F-9268-B95E886B2F7A}</Project>
-      <Name>HeuristicLab.Services.OKB.DataTransfer-3.3</Name>
-    </ProjectReference>
     <ProjectReference Include="..\..\..\HeuristicLab.Services.OKB\3.3\HeuristicLab.Services.OKB-3.3.csproj">
       <Project>{766DA4B7-2A0E-4CDE-8F90-93D8B1AD62CF}</Project>
Index: branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/HeuristicLab.Services.OKB-3.3.csproj
===================================================================
--- branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/HeuristicLab.Services.OKB-3.3.csproj	(revision 5482)
+++ branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/HeuristicLab.Services.OKB-3.3.csproj	(revision 5502)
@@ -134,8 +134,7 @@
     <Compile Include="Authentication\DataTransfer\User.cs" />
     <Compile Include="Authentication\IAuthenticationService.cs" />
-    <Compile Include="Convert.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
+    <Compile Include="Query\Convert.cs" />
     <Compile Include="Query\DataTransfer\Algorithm.cs" />
-    <Compile Include="Query\DataTransfer\AlgorithmClass.cs" />
     <Compile Include="Query\DataTransfer\BinaryValue.cs" />
     <Compile Include="Query\DataTransfer\BooleanOperation.cs" />
@@ -163,7 +162,5 @@
     <Compile Include="Query\DataTransfer\OrdinalComparisonIntFilter.cs" />
     <Compile Include="Query\DataTransfer\OrdinalComparisonLongFilter.cs" />
-    <Compile Include="Query\DataTransfer\Platform.cs" />
     <Compile Include="Query\DataTransfer\Problem.cs" />
-    <Compile Include="Query\DataTransfer\ProblemClass.cs" />
     <Compile Include="Query\DataTransfer\Run.cs" />
     <Compile Include="Query\DataTransfer\StringComparison.cs" />
@@ -175,37 +172,24 @@
       <SubType>Code</SubType>
     </Compile>
-    <Compile Include="Query\Filters\AlgorithmDataDataTypeNameFilter.cs">
-      <SubType>Code</SubType>
-    </Compile>
     <Compile Include="Query\Filters\AlgorithmNameFilter.cs">
       <SubType>Code</SubType>
     </Compile>
-    <Compile Include="Query\Filters\AlgorithmParameterBlobValueDataTypeNameFilter.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="Query\Filters\AlgorithmParameterBlobValueValueFilter.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="Query\Filters\AlgorithmParameterBoolValueValueFilter.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="Query\Filters\AlgorithmParameterFloatValueValueFilter.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="Query\Filters\AlgorithmParameterIntValueValueFilter.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="Query\Filters\AlgorithmParameterNameFilter.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="Query\Filters\AlgorithmParameterStringValueValueFilter.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="Query\Filters\AlgorithmPlatformNameFilter.cs">
-      <SubType>Code</SubType>
-    </Compile>
     <Compile Include="Query\Filters\AndFilter.cs">
       <SubType>Code</SubType>
     </Compile>
+    <Compile Include="Query\Filters\AlgorithmDataTypeNameFilter.cs" />
+    <Compile Include="Query\Filters\AlgorithmPlatformNameFilter.cs" />
+    <Compile Include="Query\Filters\BoolValueFilter.cs" />
+    <Compile Include="Query\Filters\BinaryValueFilter.cs" />
+    <Compile Include="Query\Filters\StringValueFilter.cs" />
+    <Compile Include="Query\Filters\FloatValueFilter.cs" />
+    <Compile Include="Query\Filters\DoubleValueFilter.cs" />
+    <Compile Include="Query\Filters\LongValueFilter.cs" />
+    <Compile Include="Query\Filters\IntValueFilter.cs">
+      <SubType>Code</SubType>
+    </Compile>
+    <Compile Include="Query\Filters\ValueDataTypeNameFilter.cs" />
+    <Compile Include="Query\Filters\ProblemPlatformNameFilter.cs" />
+    <Compile Include="Query\Filters\ProblemDataTypeNameFilter.cs" />
     <Compile Include="Query\Filters\IFilter.cs" />
     <Compile Include="Query\Filters\OrFilter.cs">
@@ -215,55 +199,7 @@
       <SubType>Code</SubType>
     </Compile>
-    <Compile Include="Query\Filters\ProblemDataDataTypeNameFilter.cs">
-      <SubType>Code</SubType>
-    </Compile>
     <Compile Include="Query\Filters\ProblemNameFilter.cs">
       <SubType>Code</SubType>
     </Compile>
-    <Compile Include="Query\Filters\ProblemParameterBlobValueDataTypeNameFilter.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="Query\Filters\ProblemParameterBlobValueValueFilter.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="Query\Filters\ProblemParameterBoolValueValueFilter.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="Query\Filters\ProblemParameterFloatValueValueFilter.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="Query\Filters\ProblemParameterIntValueValueFilter.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="Query\Filters\ProblemParameterNameFilter.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="Query\Filters\ProblemParameterStringValueValueFilter.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="Query\Filters\ProblemPlatformNameFilter.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="Query\Filters\ResultBlobValueDataTypeNameFilter.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="Query\Filters\ResultBlobValueValueFilter.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="Query\Filters\ResultBoolValueValueFilter.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="Query\Filters\ResultFloatValueValueFilter.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="Query\Filters\ResultIntValueValueFilter.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="Query\Filters\ResultNameFilter.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="Query\Filters\ResultStringValueValueFilter.cs">
-      <SubType>Code</SubType>
-    </Compile>
     <Compile Include="Query\Filters\RunClientNameFilter.cs">
       <SubType>Code</SubType>
@@ -278,6 +214,11 @@
       <SubType>Code</SubType>
     </Compile>
+    <Compile Include="Query\Filters\ValueNameFilter.cs">
+      <SubType>Code</SubType>
+    </Compile>
     <Compile Include="Query\IQueryService.cs" />
-    <Compile Include="Query\QueryService.cs" />
+    <Compile Include="Query\QueryService.cs">
+      <SubType>Code</SubType>
+    </Compile>
     <Compile Include="RunCreation\Convert.cs" />
     <Compile Include="RunCreation\DataTransfer\Algorithm.cs" />
@@ -310,8 +251,4 @@
       <Name>HeuristicLab.Services.OKB.DataAccess-3.3</Name>
     </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.Services.OKB.DataTransfer\3.3\HeuristicLab.Services.OKB.DataTransfer-3.3.csproj">
-      <Project>{209FD7A1-DFB2-4B9F-9268-B95E886B2F7A}</Project>
-      <Name>HeuristicLab.Services.OKB.DataTransfer-3.3</Name>
-    </ProjectReference>
   </ItemGroup>
   <ItemGroup />
Index: branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/Convert.cs
===================================================================
--- branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/Convert.cs	(revision 5502)
+++ branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/Convert.cs	(revision 5502)
@@ -0,0 +1,73 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Linq;
+using DA = HeuristicLab.Services.OKB.DataAccess;
+using DT = HeuristicLab.Services.OKB.Query.DataTransfer;
+
+namespace HeuristicLab.Services.OKB.Query {
+  public static class Convert {
+    public static DT.Run ToDto(DA.Run source, bool includeBinaryValues) {
+      if (source == null) return null;
+      var dto = new DT.Run { Id = source.Id, Algorithm = Convert.ToDto(source.Algorithm), Problem = Convert.ToDto(source.Problem), CreatedDate = source.CreatedDate, RandomSeed = source.RandomSeed, ClientId = source.ClientId, UserId = source.UserId };
+      dto.ParameterValues = source.Values.Where(x => x.ValueName.Category == DA.ValueNameCategory.Parameter).Select(x => Convert.ToDto(x, includeBinaryValues)).ToArray();
+      dto.ResultValues = source.Values.Where(x => x.ValueName.Category == DA.ValueNameCategory.Result).Select(x => Convert.ToDto(x, includeBinaryValues)).ToArray();
+      return dto;
+    }
+
+    private static DT.Algorithm ToDto(DA.Algorithm source) {
+      if (source == null) return null;
+      return new DT.Algorithm { Name = source.Name, Description = source.Description, AlgorithmClass = source.AlgorithmClass.Name, Platform = source.Platform.Name, DataType = Convert.ToDto(source.DataType) };
+    }
+
+    private static DT.Problem ToDto(DA.Problem source) {
+      if (source == null) return null;
+      return new DT.Problem { Name = source.Name, Description = source.Description, ProblemClass = source.ProblemClass.Name, Platform = source.Platform.Name, DataType = Convert.ToDto(source.DataType) };
+    }
+
+    private static DT.DataType ToDto(DA.DataType source) {
+      if (source == null) return null;
+      return new DT.DataType { Name = source.Name, TypeName = source.TypeName };
+    }
+
+    private static DT.Value ToDto(DA.Value source, bool includeBinaryValues) {
+      if (source == null) return null;
+      if (source.ValueName.Type == DA.ValueNameType.Bool) {
+        return new DT.BoolValue { Name = source.ValueName.Name, DataType = Convert.ToDto(source.DataType), Value = source.BoolValue.GetValueOrDefault() };
+      } else if (source.ValueName.Type == DA.ValueNameType.Int) {
+        return new DT.IntValue { Name = source.ValueName.Name, DataType = Convert.ToDto(source.DataType), Value = source.IntValue.GetValueOrDefault() };
+      } else if (source.ValueName.Type == DA.ValueNameType.Long) {
+        return new DT.LongValue { Name = source.ValueName.Name, DataType = Convert.ToDto(source.DataType), Value = source.LongValue.GetValueOrDefault() };
+      } else if (source.ValueName.Type == DA.ValueNameType.Float) {
+        return new DT.FloatValue { Name = source.ValueName.Name, DataType = Convert.ToDto(source.DataType), Value = source.FloatValue.GetValueOrDefault() };
+      } else if (source.ValueName.Type == DA.ValueNameType.Double) {
+        return new DT.DoubleValue { Name = source.ValueName.Name, DataType = Convert.ToDto(source.DataType), Value = source.DoubleValue.GetValueOrDefault() };
+      } else if (source.ValueName.Type == DA.ValueNameType.String) {
+        return new DT.StringValue { Name = source.ValueName.Name, DataType = Convert.ToDto(source.DataType), Value = source.StringValue };
+      } else if (source.ValueName.Type == DA.ValueNameType.Binary) {
+        return new DT.BinaryValue { Name = source.ValueName.Name, DataType = Convert.ToDto(source.DataType), Value = includeBinaryValues ? source.BinaryData.Data.ToArray() : null };
+      } else {
+        throw new ArgumentException("Unknown value type.", "source");
+      }
+    }
+  }
+}
Index: branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/DataTransfer/Algorithm.cs
===================================================================
--- branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/DataTransfer/Algorithm.cs	(revision 5482)
+++ branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/DataTransfer/Algorithm.cs	(revision 5502)
@@ -30,7 +30,7 @@
     public string Description { get; set; }
     [DataMember]
-    public Platform Platform { get; set; }
+    public string Platform { get; set; }
     [DataMember]
-    public AlgorithmClass AlgorithmClass { get; set; }
+    public string AlgorithmClass { get; set; }
     [DataMember]
     public DataType DataType { get; set; }
Index: branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/DataTransfer/BinaryValue.cs
===================================================================
--- branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/DataTransfer/BinaryValue.cs	(revision 5482)
+++ branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/DataTransfer/BinaryValue.cs	(revision 5502)
@@ -26,5 +26,5 @@
   public class BinaryValue : Value {
     [DataMember]
-    public long BinaryDataId { get; set; }
+    public byte[] Value { get; set; }
   }
 }
Index: branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/DataTransfer/Problem.cs
===================================================================
--- branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/DataTransfer/Problem.cs	(revision 5482)
+++ branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/DataTransfer/Problem.cs	(revision 5502)
@@ -30,7 +30,7 @@
     public string Description { get; set; }
     [DataMember]
-    public Platform Platform { get; set; }
+    public string Platform { get; set; }
     [DataMember]
-    public ProblemClass ProblemClass { get; set; }
+    public string ProblemClass { get; set; }
     [DataMember]
     public DataType DataType { get; set; }
Index: branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/Filters/AlgorithmClassNameFilter.cs
===================================================================
--- branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/Filters/AlgorithmClassNameFilter.cs	(revision 5482)
+++ branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/Filters/AlgorithmClassNameFilter.cs	(revision 5502)
@@ -21,4 +21,5 @@
 
 using System;
+using System.Data.Linq.SqlClient;
 using System.Linq.Expressions;
 using HeuristicLab.Services.OKB.DataAccess;
@@ -33,11 +34,15 @@
         switch (Comparison) {
           case DataTransfer.StringComparison.Equal:
-            return x => x.Experiment.Algorithm.AlgorithmClass.Name == Value;
+            return x => x.Algorithm.AlgorithmClass.Name == Value;
           case DataTransfer.StringComparison.NotEqual:
-            return x => x.Experiment.Algorithm.AlgorithmClass.Name != Value;
+            return x => x.Algorithm.AlgorithmClass.Name != Value;
           case DataTransfer.StringComparison.Contains:
-            return x => x.Experiment.Algorithm.AlgorithmClass.Name.Contains(Value);
+            return x => x.Algorithm.AlgorithmClass.Name.Contains(Value);
           case DataTransfer.StringComparison.NotContains:
-            return x => !x.Experiment.Algorithm.AlgorithmClass.Name.Contains(Value);
+            return x => !x.Algorithm.AlgorithmClass.Name.Contains(Value);
+          case DataTransfer.StringComparison.Like:
+            return x => SqlMethods.Like(x.Algorithm.AlgorithmClass.Name, Value);
+          case DataTransfer.StringComparison.NotLike:
+            return x => !SqlMethods.Like(x.Algorithm.AlgorithmClass.Name, Value);
           default:
             return x => true;
@@ -50,5 +55,5 @@
       Value = value;
     }
-    public AlgorithmClassNameFilter(DataTransfer.SetComparisonStringFilter filter) {
+    public AlgorithmClassNameFilter(DataTransfer.StringComparisonFilter filter) {
       Comparison = filter.Comparison;
       Value = filter.Value;
Index: branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/Filters/AlgorithmDataTypeNameFilter.cs
===================================================================
--- branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/Filters/AlgorithmDataTypeNameFilter.cs	(revision 5502)
+++ branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/Filters/AlgorithmDataTypeNameFilter.cs	(revision 5502)
@@ -0,0 +1,62 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Data.Linq.SqlClient;
+using System.Linq.Expressions;
+using HeuristicLab.Services.OKB.DataAccess;
+
+namespace HeuristicLab.Services.OKB.Query.Filters {
+  public class AlgorithmDataTypeNameFilter : IFilter {
+    public DataTransfer.StringComparison Comparison { get; set; }
+    public string Value { get; set; }
+
+    public Expression<Func<Run, bool>> Expression {
+      get {
+        switch (Comparison) {
+          case DataTransfer.StringComparison.Equal:
+            return x => x.Algorithm.DataType.Name == Value;
+          case DataTransfer.StringComparison.NotEqual:
+            return x => x.Algorithm.DataType.Name != Value;
+          case DataTransfer.StringComparison.Contains:
+            return x => x.Algorithm.DataType.Name.Contains(Value);
+          case DataTransfer.StringComparison.NotContains:
+            return x => !x.Algorithm.DataType.Name.Contains(Value);
+          case DataTransfer.StringComparison.Like:
+            return x => SqlMethods.Like(x.Algorithm.DataType.Name, Value);
+          case DataTransfer.StringComparison.NotLike:
+            return x => !SqlMethods.Like(x.Algorithm.DataType.Name, Value);
+          default:
+            return x => true;
+        }
+      }
+    }
+
+    public AlgorithmDataTypeNameFilter(DataTransfer.StringComparison comparison, string value) {
+      Comparison = comparison;
+      Value = value;
+    }
+    public AlgorithmDataTypeNameFilter(DataTransfer.StringComparisonFilter filter) {
+      Comparison = filter.Comparison;
+      Value = filter.Value;
+    }
+  }
+}
Index: branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/Filters/AlgorithmNameFilter.cs
===================================================================
--- branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/Filters/AlgorithmNameFilter.cs	(revision 5482)
+++ branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/Filters/AlgorithmNameFilter.cs	(revision 5502)
@@ -21,4 +21,5 @@
 
 using System;
+using System.Data.Linq.SqlClient;
 using System.Linq.Expressions;
 using HeuristicLab.Services.OKB.DataAccess;
@@ -33,11 +34,15 @@
         switch (Comparison) {
           case DataTransfer.StringComparison.Equal:
-            return x => x.Experiment.Algorithm.Name == Value;
+            return x => x.Algorithm.Name == Value;
           case DataTransfer.StringComparison.NotEqual:
-            return x => x.Experiment.Algorithm.Name != Value;
+            return x => x.Algorithm.Name != Value;
           case DataTransfer.StringComparison.Contains:
-            return x => x.Experiment.Algorithm.Name.Contains(Value);
+            return x => x.Algorithm.Name.Contains(Value);
           case DataTransfer.StringComparison.NotContains:
-            return x => !x.Experiment.Algorithm.Name.Contains(Value);
+            return x => !x.Algorithm.Name.Contains(Value);
+          case DataTransfer.StringComparison.Like:
+            return x => SqlMethods.Like(x.Algorithm.Name, Value);
+          case DataTransfer.StringComparison.NotLike:
+            return x => !SqlMethods.Like(x.Algorithm.Name, Value);
           default:
             return x => true;
@@ -50,5 +55,5 @@
       Value = value;
     }
-    public AlgorithmNameFilter(DataTransfer.SetComparisonStringFilter filter) {
+    public AlgorithmNameFilter(DataTransfer.StringComparisonFilter filter) {
       Comparison = filter.Comparison;
       Value = filter.Value;
Index: branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/Filters/AlgorithmPlatformNameFilter.cs
===================================================================
--- branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/Filters/AlgorithmPlatformNameFilter.cs	(revision 5482)
+++ branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/Filters/AlgorithmPlatformNameFilter.cs	(revision 5502)
@@ -21,4 +21,5 @@
 
 using System;
+using System.Data.Linq.SqlClient;
 using System.Linq.Expressions;
 using HeuristicLab.Services.OKB.DataAccess;
@@ -33,11 +34,15 @@
         switch (Comparison) {
           case DataTransfer.StringComparison.Equal:
-            return x => x.Experiment.Algorithm.Platform.Name == Value;
+            return x => x.Algorithm.Platform.Name == Value;
           case DataTransfer.StringComparison.NotEqual:
-            return x => x.Experiment.Algorithm.Platform.Name != Value;
+            return x => x.Algorithm.Platform.Name != Value;
           case DataTransfer.StringComparison.Contains:
-            return x => x.Experiment.Algorithm.Platform.Name.Contains(Value);
+            return x => x.Algorithm.Platform.Name.Contains(Value);
           case DataTransfer.StringComparison.NotContains:
-            return x => !x.Experiment.Algorithm.Platform.Name.Contains(Value);
+            return x => !x.Algorithm.Platform.Name.Contains(Value);
+          case DataTransfer.StringComparison.Like:
+            return x => SqlMethods.Like(x.Algorithm.Platform.Name, Value);
+          case DataTransfer.StringComparison.NotLike:
+            return x => !SqlMethods.Like(x.Algorithm.Platform.Name, Value);
           default:
             return x => true;
@@ -50,5 +55,5 @@
       Value = value;
     }
-    public AlgorithmPlatformNameFilter(DataTransfer.SetComparisonStringFilter filter) {
+    public AlgorithmPlatformNameFilter(DataTransfer.StringComparisonFilter filter) {
       Comparison = filter.Comparison;
       Value = filter.Value;
Index: branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/Filters/AndFilter.cs
===================================================================
--- branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/Filters/AndFilter.cs	(revision 5482)
+++ branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/Filters/AndFilter.cs	(revision 5502)
@@ -22,4 +22,5 @@
 using System;
 using System.Collections.Generic;
+using System.Linq;
 using System.Linq.Expressions;
 using HeuristicLab.Services.OKB.DataAccess;
Index: branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/Filters/BinaryValueFilter.cs
===================================================================
--- branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/Filters/BinaryValueFilter.cs	(revision 5502)
+++ branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/Filters/BinaryValueFilter.cs	(revision 5502)
@@ -0,0 +1,57 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Linq;
+using System.Linq.Expressions;
+using HeuristicLab.Services.OKB.DataAccess;
+
+namespace HeuristicLab.Services.OKB.Query.Filters {
+  public class BinaryValueFilter : IFilter {
+    public string Name { get; protected set; }
+    public DataTransfer.EqualityComparison Comparison { get; set; }
+    public byte[] Value { get; set; }
+
+    public Expression<Func<Run, bool>> Expression {
+      get {
+        switch (Comparison) {
+          case DataTransfer.EqualityComparison.Equal:
+            return x => x.Values.Any(y => (y.ValueName.Name == Name) && (y.BinaryData.Data == Value));
+          case DataTransfer.EqualityComparison.NotEqual:
+            return x => x.Values.Any(y => (y.ValueName.Name == Name) && (y.BinaryData.Data != Value));
+          default:
+            return x => true;
+        }
+      }
+    }
+
+    public BinaryValueFilter(string name, DataTransfer.EqualityComparison comparison, byte[] value) {
+      Name = name;
+      Comparison = comparison;
+      Value = value;
+    }
+    public BinaryValueFilter(DataTransfer.NameEqualityComparisonByteArrayFilter filter) {
+      Name = filter.Name;
+      Comparison = filter.Comparison;
+      Value = filter.Value;
+    }
+  }
+}
